%global momorel 2
%define peardir %{_datadir}/pear

%define xmlrpcver 1.5.1
%define getoptver 1.2.3
%define arctarver 1.3.2
%define structver 1.0.2

# Upstream only make the latest .phar available via the following URL,
# no archive of each version of the installer archives exists:
#   http://pear.php.net/install-pear-nozlib.phar

Summary: PHP Extension and Application Repository framework
Name: php-pear
Version: 1.7.2
Release: %{momorel}m%{dist}
Epoch: 1
License: "The PHP License v3.0"
Group: Development/Languages
URL: http://pear.php.net/package/PEAR
Source0: http://download.pear.php.net/package/PEAR-%{version}.tgz
# wget http://cvs.php.net/viewvc.cgi/pear-core/install-pear.php?revision=1.29 -O install-pear.php
Source1: install-pear.php
Source2: relocate.php
Source3: strip.php
Source4: LICENSE
Source10: pear.sh
Source11: pecl.sh
Source12: peardev.sh
Source13: macros.pear
Source20: http://pear.php.net/get/XML_RPC-%{xmlrpcver}.tgz
Source21: http://pear.php.net/get/Archive_Tar-%{arctarver}.tgz
Source22: http://pear.php.net/get/Console_Getopt-%{getoptver}.tgz
Source23: http://pear.php.net/get/Structures_Graph-%{structver}.tgz
NoSource: 0
NoSource: 20
NoSource: 21
NoSource: 22
NoSource: 23
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: php-cli >= 5.1.0-1, gnupg
Provides: php-pear(Archive_Tar) = 1.3.2
Provides: php-pear(Console_Getopt) = 1.2.1
Provides: php-pear(PEAR) = %{version}
Provides: php-pear(Structures_Graph) = 1.0.2
Provides: php-pear(XML_RPC) = %{xmlrpcver}
Requires: php >= 5.1.0-1, php-cli

%description
PEAR is a framework and distribution system for reusable PHP
components.  This package contains the basic PEAR components.

%prep
%setup -cT

# Create a usable PEAR directory (used by install-pear.php)
for archive in %{SOURCE0} %{SOURCE21} %{SOURCE22} %{SOURCE23}
do
    tar xzf  $archive --strip-components 1
done

# apply patches on used PEAR during install
# -- no patch

%build
# This is an empty build section.

%install
rm -rf $RPM_BUILD_ROOT

export PHP_PEAR_SYSCONF_DIR=%{_sysconfdir}
export PHP_PEAR_SIG_KEYDIR=%{_sysconfdir}/pearkeys
export PHP_PEAR_SIG_BIN=%{_bindir}/gpg
export PHP_PEAR_INSTALL_DIR=%{peardir}

# 1.4.11 tries to write to the cache directory during installation
# so it's not possible to set a sane default via the environment.
# The ${PWD} bit will be stripped via relocate.php later.
export PHP_PEAR_CACHE_DIR=${PWD}%{_localstatedir}/cache/php-pear
export PHP_PEAR_TEMP_DIR=/var/tmp

install -d $RPM_BUILD_ROOT%{peardir} \
           $RPM_BUILD_ROOT%{_localstatedir}/cache/php-pear \
           $RPM_BUILD_ROOT%{peardir}/.pkgxml \
           $RPM_BUILD_ROOT%{_sysconfdir}/rpm

export INSTALL_ROOT=$RPM_BUILD_ROOT

%{_bindir}/php -n -dmemory_limit=32M -dshort_open_tag=0 -dsafe_mode=0 \
         -derror_reporting=E_ALL -ddetect_unicode=0 \
      %{SOURCE1} -d %{peardir} \
                 -b %{_bindir} \
                 %{SOURCE0} %{SOURCE21} %{SOURCE22} %{SOURCE23} %{SOURCE20}

# Replace /usr/bin/* with simple scripts:
for f in pecl pear peardev; do 
   install -m 755 $RPM_SOURCE_DIR/${f}.sh $RPM_BUILD_ROOT%{_bindir}/${f}
done

# Sanitize the pear.conf
%{_bindir}/php -n %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf $RPM_BUILD_ROOT | 
  %{_bindir}/php -n %{SOURCE2} php://stdin $PWD > new-pear.conf
%{_bindir}/php -n %{SOURCE3} new-pear.conf ext_dir > $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf

install -m 644 -c $RPM_SOURCE_DIR/LICENSE .

install -m 644 -c $RPM_SOURCE_DIR/macros.pear \
           $RPM_BUILD_ROOT%{_sysconfdir}/rpm/macros.pear        

# apply patches on installed PEAR tree
cd $RPM_BUILD_ROOT%{peardir} 
# -- no patch

# Why this file here ?
rm -rf $RPM_BUILD_ROOT/.depdb* $RPM_BUILD_ROOT/.lock $RPM_BUILD_ROOT/.channels $RPM_BUILD_ROOT/.filemap

%check
# Check that no bogus paths are left in the configuration, or in
# the generated registry files.
grep $RPM_BUILD_ROOT $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf && exit 1
grep %{_libdir} $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf && exit 1
grep '"/tmp"' $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf && exit 1
grep /usr/local $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf && exit 1
grep -rl $RPM_BUILD_ROOT $RPM_BUILD_ROOT && exit 1

%clean
rm -rf $RPM_BUILD_ROOT
rm new-pear.conf

%files
%defattr(-,root,root,-)
%{peardir}
%{_bindir}/*
%config(noreplace) %{_sysconfdir}/pear.conf
%config %{_sysconfdir}/rpm/macros.pear
%dir %{_localstatedir}/cache/php-pear
%doc LICENSE

%changelog
* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.7.2-2m)
- rebuild against rpm-4.6

* Sun Jul 27 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (1.7.2-1m)
- update to 1.7.2

* Mon May 05 2008 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (1.6.2-3m)
- rebuild against php 5.2.6

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.6.2-2m)
- rebuild against gcc43

* Mon Sep 17 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.6.2-1m)
- update to 1.6.2
- sync with Fedora devel

* Wed Jun 13 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.6.0-1m)
- [SECURITY] CVE-2007-2519
- update to 1.6.0

* Sat May 12 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (1.5.0-1m)
- sync fedora

* Sun Apr 15 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.4.6-3m)
- rebuild against php-5.2.1

* Mon Feb 27 2006 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- fix pear.conf locaion.

* Mon Feb 27 2006 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- update to 1.4.6

* Fri Dec 9 2005 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- import from fedora

* Tue Dec  6 2005 Joe Orton <jorton@redhat.com> 1:1.4.5-4
- fix virtual provide for PEAR package (#175074)

* Sun Dec  4 2005 Joe Orton <jorton@redhat.com> 1:1.4.5-3
- fix /usr/bin/{pecl,peardev} (#174882)

* Thu Dec  1 2005 Joe Orton <jorton@redhat.com> 1:1.4.5-2
- add virtual provides (#173806) 

* Wed Nov 23 2005 Joe Orton <jorton@redhat.com> 1.4.5-1
- initial build (Epoch: 1 to allow upgrade from php-pear-5.x)

